import Flutter
import UIKit

import ReplayKit

public class SwiftNorgicVdotokPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {


    let factory = FLNativeViewFactory(messenger: registrar.messenger())
        registrar.register(factory, withId: "<platform-view-type>")
    // let channel = FlutterMethodChannel(name: "vdotok_stream", binaryMessenger: registrar.messenger())
    // let instance = SwiftNorgicVdotokPlugin()
    // registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    result("iOS " + UIDevice.current.systemVersion)
  }
}

public class FLNativeViewFactory: NSObject, FlutterPlatformViewFactory {
    private var messenger: FlutterBinaryMessenger

    init(messenger: FlutterBinaryMessenger) {
        self.messenger = messenger
        super.init()
    }

  public  func create(
        withFrame frame: CGRect,
        viewIdentifier viewId: Int64,
        arguments args: Any?
    ) -> FlutterPlatformView {
        return FLNativeView(
            frame: frame,
            viewIdentifier: viewId,
            arguments: args,
            binaryMessenger: messenger)
    }
}

class FLNativeView: NSObject, FlutterPlatformView {
    private var _view: UIView

    init(
        frame: CGRect,
        viewIdentifier viewId: Int64,
        arguments args: Any?,
        binaryMessenger messenger: FlutterBinaryMessenger?
    ) {
        _view = UIView()
        super.init()
        // iOS views can be created here
        createNativeView(view: _view)
    }

    func view() -> UIView {
        return _view
    }

 public   func createNativeView(view _view: UIView){
      if #available(iOS 12.0, *) {
      let pickerView = RPSystemBroadcastPickerView(frame: CGRect(x: 0, y: 0, width: 50, height: 50))
        pickerView.preferredExtension = "com.norgic.vdotok.sharescreen"

        // containerView.addSubview(broadcastPicker)
      pickerView.translatesAutoresizingMaskIntoConstraints = false
      
      // Update the color of the Button 
      // to make it visible clearly on a white background
      if let button = pickerView.subviews.first as? UIButton {
        button.imageView?.tintColor = UIColor.red
      }
      
      _view.addSubview(pickerView)
    } else {
       _view.backgroundColor = UIColor.blue
      let label = UILabel()
      label.text = "Screen Recording Not Supported"
      label.textColor = UIColor.black
      label.frame = CGRect(x: 0, y: 0, width: 180, height: 48.0)
      _view.addSubview(label)
    }
        // _view.backgroundColor = UIColor.blue
        // let nativeLabel = UILabel()
        // nativeLabel.text = "Native text from iOS"
        // nativeLabel.textColor = UIColor.white
        // nativeLabel.textAlignment = .center
        // nativeLabel.frame = CGRect(x: 0, y: 0, width: 180, height: 48.0)
        // _view.addSubview(nativeLabel)
    }
}
