import 'dart:async';
import 'dart:io' show Platform;
import 'dart:typed_data';
import 'package:device_info/device_info.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:flutter_webrtc/flutter_webrtc.dart';
import 'package:media_projection_creator/media_projection_creator.dart';
import 'package:vdotok_stream/src/signaling/web_socket_connection.dart';
import 'package:vdotok_stream/src/utils/config.dart';
import 'dart:convert';
import 'package:flutter_device_type/flutter_device_type.dart';
import 'package:crypto/crypto.dart';
import 'package:replay_kit_launcher/replay_kit_launcher.dart';
import 'package:http/http.dart' as http;
import 'package:dart_ipify/dart_ipify.dart';

typedef void OnConnectCallback(String res);
typedef void OnRegisterCallback(Map<String, dynamic> res);
//typedef void ReRegisterCallback(Map<String, dynamic> res,String project_id);
typedef void OnErrorCallback(int code, String reason);
typedef void OnLocalStreamCallback(MediaStream stream);
typedef void OnRemoteStreamCallback(MediaStream stream, String refID);
typedef void OnReceiveCallFromUserCallback(
    String receivefrom, String type, bool callonetoone);
typedef void OnAudioVideoStateInfoCallback(
    int audioFlag, int videoFlag, String refID);
typedef void OnCallRejectedByUserCallback();
typedef void OnCallAcceptedByUserCallback();
typedef void OnCallHungUpByUserCallback(bool isLocal);
typedef void OnCallDeclineByYouCallback();
typedef void OnCallBusyCallback();
typedef void OnCallWaitingCallback();
typedef void OnParticipantsLeftCallback(String refID);
typedef void OnCallStats(var timeStatsdownloads, var timeStatsuploads);
typedef void OnCallStatsUploads(var uploadstats);

typedef void OnCallMissedCallback();

class SignalingClient {
  // IOWebSocketChannel _socket;
  static final SignalingClient _instance =
      SignalingClient._privateConstructor();
  static SignalingClient get instance => _instance;
  SignalingClient._privateConstructor();
  //callbacks
  OnConnectCallback onConnect;
  OnErrorCallback onError;
  OnRegisterCallback onRegister;
  //ReRegisterCallback reRegister;
  //bool iscallreconnected = false;
  //String participntleftreferenceid = "";

  OnCallMissedCallback onCallMissedCallback;

  OnLocalStreamCallback onLocalStream;
  OnRemoteStreamCallback onRemoteStream;
  OnReceiveCallFromUserCallback onReceiveCallFromUser;
  OnCallRejectedByUserCallback onCallRejectedByUser;
  OnCallAcceptedByUserCallback onCallAcceptedByUser;
  OnCallHungUpByUserCallback onCallHungUpByUser;
  OnCallDeclineByYouCallback onCallDeclineByYou;
  OnCallBusyCallback onCallBusyCallback;
  OnCallWaitingCallback onCallWaitingCallback;
  OnAudioVideoStateInfoCallback onAudioVideoStateInfo;
  OnParticipantsLeftCallback onParticipantsLeft;
  OnCallStats onCallstats;
  OnCallStatsUploads onCallStatsuploads;
  WebSocketConnection _socket;
  RTCPeerConnection _peerConnection;
  RTCPeerConnection _peerConnection2;
  Map<String, RTCPeerConnection> rtcPeerConnectionList = {};
  MediaStream _localStream;
  MediaStream _audioStream;
  MediaStream _audioInternalStream;
  // MediaStream stream;
  Map<String, RTCPeerConnection> requestIDType = {};
  String tenantID = "12345";
  String ref_id;
  String sessionUUID;
  bool screenShareflag = false;
  Stream sStream;
  String onetooneparticipantrefid = "";
  var statsss = 0;
  String mcTokenCurrent;
  String deviceCategory;
  String userType;
  DateTime starttime;
  String deviceType;
  String deviceModel;
  int bytesInterval;
  bool callend = false;
  String mediatype;
  String mcToken;
  String otheruserrefid = "";
  int reConnectCall = 0;
  Timer _timer;
  int _start = 0;
  int incrementvariable = 0;
  bool iscallonetoone = false;
  bool reCall = false;
  Map<String, dynamic> byteObject;
  Map<String, dynamic> startCallObject;
  Map<String, dynamic> byteObjectupload;
  List<MediaStream> remoteStreams;
  String referenceID;
  List<String> callParticipants = [];
  static const MethodChannel _channel = const MethodChannel('flutter_vdotok');
  int isCallStart = 0;
  int callversions = 0;
  // Future<dynamic> callAPI(auth_token, project_id) async {
  //   final datarequest = {"auth_token": auth_token, "project_id": project_id};
  //   print("this is host in authenticate $host");
  //   var url = Uri.parse(host);
  //   final response = await http.post(
  //     url,
  //     body: json.encode(datarequest),
  //   );
  //   print("this is response of Api call-- ${json.decode(response.body)}");
  //   if (response.statusCode == 200) {
  //     print("${response.statusCode}");
  //     return json.decode(response.body);
  //   } else {
  //     print("i am here in else authenticate sdk");
  //     throw Exception("Failed to Load Data");
  //   }
  // }

  Stream<int> numberStream() async* {
    // for(int i = 1; i<= 10; i++) {
    //   await Future.delayed(Duration(seconds: 1));

    yield 20;
    // }
    yield await _channel.invokeMethod('getInternalAudio', {"audio": true});
  }

  Future<void> connect(project_id, completeAddress) async {
    print("here in connect in sdk");

    _socket = WebSocketConnection(url: completeAddress);
    //   WebSocketConnection(url: "wss://vtk1.vdotok.dev:8443/call");

    _socket.onOpen = () {
      print('onOpen');
      onConnect.call("connected");
    };

    _socket.onMessage = (message) {
      // print('Received data: ' + message);
      onMessage(json.decode(message));
    };

    _socket.onClose = (int code, String reason) {
      print("this is onclose socket");
      onError.call(code, reason);
      // print('Closed by server [$code => $reason]!');
      // onSignalingStateChange?.call(SignalingState.ConnectionClosed);
    };

    await _socket.connect();
  }

  closeSocket() {
    if (_socket != null) _socket.close();
  }

  void onMessage(message) async {
    Map<String, dynamic> mapData = message;
    print("this is data ideee ${mapData["requestType"]}");
    print("THSI IS RECOOECT2 ${mapData}");

    switch (mapData["requestType"]) {
      //for register
      case 'register':
        if (mapData["responseCode"] == 200) {
          bytesInterval = mapData["bytes_interval"];
          print(
              "this is map data in register  ${mapData["bytes_interval"]}.....$bytesInterval");
          if (mapData["reConnect"] == 0) {
            print("i am here in reconnect 0 ${mapData["mcToken"].toString()}");
            print("this is peer connection list in if $rtcPeerConnectionList");

            // referenceID = mapData["referenceID"];
            // print("this is reference id in register ${referenceID}");
            mcTokenCurrent = mapData["mcToken"].toString();
            print("this is mcTOken Current $mcTokenCurrent");
            onRegister.call(mapData);
          } else {
            reCall = true;
            print("i am here in reconnect 1 ${mapData["mcToken"].toString()}");

            print(
                "this is peer connection list in else $rtcPeerConnectionList");
            referenceID = mapData["referenceID"];
            if (iscallonetoone == true) {
              _peerConnection.close();
              onParticipantsLeft.call(onetooneparticipantrefid);
              print("this is map data in one to one peer connection $mapData");
            } else {
              for (int i = 0; i < callParticipants.length; i++) {
                rtcPeerConnectionList.forEach((key, value) {
                  if (key == callParticipants[i]) {
                    print(
                        "here is key $key and here is callParticipant ${callParticipants[i]}");
                    rtcPeerConnectionList[key]?.close();
                  }
                  // rtcPeerConnectionList[key]?.close();
                });
                onParticipantsLeft.call(callParticipants[i]);
                rtcPeerConnectionList.remove(callParticipants[i]);
                // await _localStream?.dispose();
                // _localStream = null;
              }
            }
            print(
                "this is peer connection list in else after remove $rtcPeerConnectionList");
            mcTokenCurrent = "";
            mcToken = mapData["mcToken"].toString();
            print("This is mcATOken in register $mcToken");
            onRegister.call(mapData);
            if (iscallonetoone == true) {
              print("i am in recoonect one to one functiin call");
              reConnectonetoone();
            } else {
              reConnect();
            }
          }

          print("this is mcToken in registerrrrrrr   ${mapData["mcToken"]}");
        } else
          onError.call(mapData["responseCode"], mapData["responseMessage"]);
        break;
      case '401':
        onError.call(mapData["responseCode"], mapData["responseMessage"]);
        break;
      //   // case 'peers':
      //   //   {
      //   //     // List<dynamic> peers = data;
      //   //     // if (onPeersUpdate != null) {
      //   //     //   Map<String, dynamic> event = Map<String, dynamic>();
      //   //     //   event['self'] = _selfId;
      //   //     //   event['peers'] = peers;
      //   //     //   onPeersUpdate?.call(event);
      //   //     // }
      //   //   }
      //   //   break;
      case 'incomingCall':
        {
          sessionUUID = mapData["sessionUUID"];
          if (mapData["call_type"] == "one_to_one") {
            onetooneparticipantrefid = mapData["from"].toString();
            print(
                "thiss is one to one incominfg ref id $onetooneparticipantrefid");
            iscallonetoone = true;
            print("this is one to one incomng mapdata $mapData");
            incomingCallonetoone(mapData);
          } else {
            incomingCall(mapData);
          }
        }
        break;
      case "session_break":
        {
          // iscallreconnected = true;
          // print(
          //     "THIS IS SESIION BREAK $iscallreconnected ${mapData["referenceID"]}");
          // participntleftreferenceid = mapData["referenceID"].toString();
        }
        break;
      case 'declineres':
        {
          print("here in decliners");
          onCallDeclineByYou.call();
          _peerConnection.close();
          iscallonetoone = false;
        }
        break;
      // startCommunication
      case 'new_participant_arrived':
        {
          print("i am in new participant arrived case");
          handleNewParticipant(mapData);
        }
        break;
      case 'existing_participants':
        {
          print("i am in existing participant case");
          handleExistingParticipant(mapData);
        }
        break;
      case 'startCommunication':
        {
          if (iscallonetoone == true) {
            callversions = callversions + 1;
            print(
                "this is answer sdp in one to one ${mapData['sdpAnswer'].toString()}");
            _peerConnection
              ..setRemoteDescription(
                  RTCSessionDescription(mapData['sdpAnswer'], "answer"));
            if (reCall == true && callversions <= 2) {
              onCallHungUpByUser.call(true);
              reCall = false;
            }
          } else {
            print(" this is start Communication ${rtcPeerConnectionList}");
            try {
              print(
                  "this is answer sdp in many to many ${mapData['sdpAnswer'].toString()}");
              if (mapData['referenceID'] == ref_id) {
                print("this is startCommunication with my ref_id");
                rtcPeerConnectionList[mapData['referenceID']]
                  ..setRemoteDescription(
                      RTCSessionDescription(mapData['sdpAnswer'], "answer"));
                print("this is local renderer in if startcom if");
                callversions = callversions + 1;
                if (callversions > 2) {
                  print("this is local renderer in if startcom if versio>2");
                  print(
                      "here in cll accept call version>2vvvvv  $callversions");
                  onCallAcceptedByUser.call();
                }
              } else {
                print("this is local renderer in else");
                print("this is startCommunication with other ref_id");
                rtcPeerConnectionList[mapData['referenceID']]
                  ..setRemoteDescription(
                      RTCSessionDescription(mapData['sdpAnswer'], "answer"));
              }
              print("tjis is recall true1");

              if (reCall == true && callversions <= 2) {
                print("this is local renderer in if startcom");
                print("tjis is recall true");
                onCallHungUpByUser.call(true);
                reCall = false;
              }
              print(
                  "this is start --${rtcPeerConnectionList[mapData["referenceID"]].getStats(_localStream.getAudioTracks()[0])}");
              // RTCSessionDescription(answerSdp, "offer"));
            } catch (e) {
              print("this is error $e");
            }
          }
        }
        break;
      case 'stopCommunication':
        {
          onCallHungUpByUser.call(false);
          _closeSession();
          print("CALLCALLLERCANCEL");
          reCall = false;
          //  iscallreconnected = false;
          callversions = 0;
          iscallonetoone = false;
          onetooneparticipantrefid = "";
        }
        break;
      case 'session_invite':
        print("this is data after accepting, ${mapData["responseCode"]}");
        if (mapData["responseCode"] == 100) {
          print("trying to locate & validate target");
        } else if (mapData["responseCode"] == 180) {
          print("trying to connect target");
        } else if (
            // Timer(Duration(seconds:10)))
            mapData["responseCode"] == 183) {
          print("target is alerting");
          // _timer=Timer.periodic(duration, (timer) { })
//  _timer = Timer.periodic(Duration(seconds: 1), (timer) {
//  _start++;
//  // print("in 10 seconds");
//  // if (mapData["responseCode"] != 200) {
//  print("in 183");
//  if (_start == 10) {
//  _timer.cancel();
//  onCallWaitingCallback.call();
//  _start = 0;
//  }

//  //_closeSession();
//  });
        }
        //else if (mapData["responseCode"] == 183) {
        //   print("target is alerting");

        //   // onCallWaitingCallback.call();
        // }
        else if (mapData["responseCode"] == 407) {
          print("authentication required");
        } else if (mapData["responseCode"] == 404) {
          print("invalid target");
          // onError.call(mapData["responseCode"], mapData["responseMessage"]);
          // _closeSession();
        } else if (mapData["responseCode"] == 480) {
          print("Temporarily Unavailable");
        } else if (mapData["responseCode"] == 403) {
          print("Service not allowed");
        } else if (mapData["responseCode"] == 408) {
          print("No Response from target");
          onError.call(mapData["responseCode"], mapData["responseMessage"]);
          _closeSession();
        } else if (mapData["responseCode"] == 486) {
          print("Target Busy");
          onCallBusyCallback.call();
          _closeSession();
          iscallonetoone = false;
        } else if (mapData["responseCode"] == 496) {
          print("rejected by user");
          onCallRejectedByUser.call();
          _closeSession();
          iscallonetoone = false;
        } else if (mapData["responseCode"] == 200) {
          print("accepted");
          // _timer.cancel();
        }
        break;
      case 'callResponse':
        {
          if (iscallonetoone == true) {
            try {
              _peerConnection
                ..setRemoteDescription(
                    RTCSessionDescription(mapData['sdpAnswer'], "answer"));
              onCallAcceptedByUser.call();
            } catch (e) {
              print("this is error in call response $e");
            }
          } else {
            try {
              callversions = callversions + 1;
              print("this is local renderer in if callresponse");
              //  if (reCall == false) {
              print("i am here in call response");
              rtcPeerConnectionList[ref_id]
                ..setRemoteDescription(
                    RTCSessionDescription(mapData['sdpAnswer'], "answer"));
              if (reCall == false) {
                print("here in cll accept again ddddd");
                onCallAcceptedByUser.call();
              } else {
                print("THIS IS CDDDDDIDDDDDD");
                onCallHungUpByUser.call(true);
              }
              reCall = false;
              if (callversions > 2) {
                print("here in cll accept call version>2 $callversions");
                onCallAcceptedByUser.call();
              }
              //  onCallAcceptedByUser.call(reCall);
              //}
            } catch (e) {
              print("this is error $e");
            }
          }
        }
        break;
      case 'iceCandidate':
        {
          if (iscallonetoone == true) {
            var candidateMap = mapData['candidate'];
            print(
                "this is iceca][]ndidate ${candidateMap['candidate']} ${candidateMap['sdpMid']} ${candidateMap['sdpMLineIndex']}");

            //       String jsonString = sdpController.text;
            // dynamic session = await jsonDecode('$jsonString');
            // print(session['candidate']);
            try {
              dynamic candidate = new RTCIceCandidate(candidateMap['candidate'],
                  candidateMap['sdpMid'], candidateMap['sdpMLineIndex']);
              print("this is icecandidate $candidate");

              await _peerConnection?.addCandidate(candidate);
            } catch (e) {
              print("this is error in ice candidate$e");
            }
          } else {
            print(
                "this is data peer connection instance${rtcPeerConnectionList},   $mapData");
            var candidateMap = mapData['candidate'];
            print(
                "this is icecandidate ${candidateMap['candidate']} ${candidateMap['sdpMid']} ${candidateMap['sdpMLineIndex']}");

            //       String jsonString = sdpController.text;
            // dynamic session = await jsonDecode('$jsonString');
            // print(session['candidate']);
            try {
              dynamic candidate = new RTCIceCandidate(candidateMap['candidate'],
                  candidateMap['sdpMid'], candidateMap['sdpMLineIndex']);
              print("this is icecandidate $candidate");

              if (mapData['referenceID'] == ref_id) {
                print(
                    "this is icecandidate with my ref_id ${rtcPeerConnectionList.containsKey(mapData['referenceID'])}    ${rtcPeerConnectionList[mapData['referenceID']]}");
                await rtcPeerConnectionList[mapData['referenceID']]
                    .addCandidate(candidate);
              } else {
                print(
                    "this is icecandidate with other ref_id ${rtcPeerConnectionList.containsKey(mapData['referenceID'])}    ${rtcPeerConnectionList[mapData['referenceID']]}");
                await rtcPeerConnectionList[mapData['referenceID']]
                    .addCandidate(candidate);
              }
              // var logger = Logger();
              // logger.d(
              //     await "this is startxcccccccc   ${rtcPeerConnectionList[mapData["referenceID"]].getStats(_localStream.getAudioTracks()[0]).asStream()}");
            } catch (e) {
              print("this is error $e");
            }
          }
        }
        break;
      case "session_cancel":
        {
          if (mapData["responseCode"] == 410) {
            _closeSessionLeftParticipant(mapData['referenceID']);
            onParticipantsLeft.call(mapData['referenceID']);
            reCall = false;
            // iscallreconnected = false;
          } else {
            if (mapData["responseMessage"] == "missed call") {
              onCallMissedCallback.call();
            }
            onCallHungUpByUser.call(false);
            _closeSession();
            print("THSIISSIISISISISI IS SESSION");
            statsEndCall();
            callversions = 0;
            callend = true;
            reCall = false;
            iscallonetoone = false;
            // iscallreconnected = false;
          }
        }
        break;
      // case "session_cancel":
      //   {
      //     if (mapData["responseCode"] == 410) {
      //       _closeSessionLeftParticipant(mapData['referenceID']);
      //       onParticipantsLeft.call(mapData['referenceID']);
      //       reCall = false;
      //       // iscallreconnected = false;
      //     } else {
      //       onCallHungUpByUser.call(false);
      //       _closeSession();
      //       print("THSIISSIISISISISI IS SESSION");
      //       statsEndCall();
      //       callversions = 0;
      //       callend = true;
      //       reCall = false;
      //       iscallonetoone=false;
      //       // iscallreconnected = false;
      //     }
      //   }
      //   break;

      case "state_information":
        {
          onAudioVideoStateInfo.call(mapData["audioInformation"],
              mapData["videoInformation"], mapData['referenceID']);
          // onCallHungUpByUser.call();
          // _closeSession();
        }
        break;
      // case "session_timeout":
      //   {
      //     print("response of session timeout");
      //     stopCall(mcToken);
      //   }
      //   break;
      //   // case 'leave':
      //   //   {
      //   //     var peerId = data as String;
      //   //     _closeSessionByPeerId(peerId);
      //   //   }
      //   //   break;
      //   // case 'bye':
      //   //   {
      //   //     var sessionId = data['session_id'];
      //   //     print('bye: ' + sessionId);
      //   //     var session = _sessions.remove(sessionId);
      //   //     onCallStateChange?.call(session, CallState.CallStateBye);
      //   //     _closeSession(session);
      //   //   }
      //   //   break;
      //   // case 'keepalive':
      //   //   {
      //   //     print('keepalive response!');
      //   //   }
      //   //   break;
      default:
        break;
    }
    if (mapData["requestType"] == "ping") {
      var response = {"requestType": "pong"};
      // const oneSec = const Duration(seconds: 2);
      // Timer.periodic(oneSec, (Timer t) => _socket.send(response));
      _socket.send(response);
    }
    // if (mapData["requestType"] == "register") {
    //   print("THSI IS INS SJABDJADBJADB");
    //  mcTokenCurrent=mapData["requestType"];
    // }
    //in case of busy user
    // if (mapData["responseCode"] == 486) {
    //   print("this is decline");
    //   onCallBusyCallback.call();
    //   _closeSession();
    // }
  }

  reConnectonetoone() async {
    _peerConnection =
        await _createPeerConnectiononetoone(type: startCallObject["mediaType"]);
    print("this is peer in one to one reconnect $_peerConnection");
    RTCSessionDescription description = await _peerConnection.createOffer({
      "OfferToReceiveAudio": 1,
      "OfferToReceiveVideo": 1,
    });
    await _peerConnection.setLocalDescription(description);
    Map<String, dynamic> offerJson = {
      "type": "request",
      "requestType": "re_invite",
      "session_type": startCallObject["sessionType"],
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "referenceID": ref_id,
      "sessionUUID": sessionUUID,
      "mcToken": mcToken,
      "sdpOffer": description.sdp.toString(),
    };
    // requestIDType[offerJson["requestID"]] = "call";
    print("this is json on create offer in one to one reconwecrt $offerJson");
    sessionUUID = offerJson["sessionUUID"];
    // channel.sink.add(offerJson);
    _socket.send(offerJson);
  }

  reConnect() async {
    //_closeSessionLeftParticipant(ref_id);
    await _createPeerConnection(type: startCallObject["mediaType"]);
    // _createOffer(
    // from: startCallObject["from"],
    // to: startCallObject["to"],
    // mcToken: mcTokenCurrent,
    // mediaType: startCallObject["mediaType"],
    // callType: startCallObject["callType"],
    // sessionType: startCallObject["sessionType"]);
    // _localStream = await _getUserMedia(type: startCallObject["mediaType"]);
    // onLocalStream.call(_localStream);
    // rtcPeerConnectionList[ref_id].addStream(_localStream);
    // print("THis is peerCOnnection List");
    // RTCSessionDescription description =
    // await rtcPeerConnectionList[ref_id].createOffer({
    // "OfferToReceiveAudio": 1,
    // "OfferToReceiveVideo": 1,
    // });
    // print("This is description ${description.sdp.toString()}");
    // await rtcPeerConnectionList[ref_id].setLocalDescription(description);
    //_localStream = await _getUserMedia(type: startCallObject["mediaType"]);
    // _localStream?.getVideoTracks()[0].enabled = false;
    // print("this is local stream ");
    // print("this is reference id in peerConnection $ref_id");
    // // rtcPeerConnectionList[ref_id] =
    // // await createPeerConnection(configuration, offerSdpConstraints);

    // print(
    // "in create peer connection $rtcPeerConnectionList ${rtcPeerConnectionList[ref_id]}");
    // var streams = pc.getLocalStreams();
    // for (var stream in streams) {
    // _localStream = stream;
    // }
    // onLocalStream.call(_localStream);
    // rtcPeerConnectionList[ref_id].addStream(_localStream);
    //rtcPeerConnectionList[ref_id].
    //rtcPeerConnectionList[ref_id].onIceConnectionState
    RTCSessionDescription description =
        await rtcPeerConnectionList[ref_id].createOffer({
      "OfferToReceiveAudio": 1,
      "OfferToReceiveVideo": 1,
    }).then((value) {
      print("this is Description sdp $value");
      return value;
    }).catchError((onError) {
      print("this is error on create offer $onError");
    });

    await rtcPeerConnectionList[ref_id]
        .setLocalDescription(description)
        .then((value) {
      print("ths is on Successfully set");
      return value;
    }).catchError((onError) {
      print('this is on Error set localDes');
    });
    print("this is on IceCandidate 12 ${description.sdp.toString()}");
    print("THis is peerCOnnection List");
    // rtcPeerConnectionList[ref_id].onIceCandidate = (e) {
    // print("this is e $e");
    // if (e.candidate != null) {
    // print("in ice candidate if");
    // Map<String, dynamic> icCandidate = {
    // "requestType": "onIceCandidate",
    // "type": "request",
    // "referenceID": ref_id,
    // "sessionUUID": sessionUUID,
    // "candidate": {
    // "candidate": "${e.candidate}",
    // "sdpMid": "${e.sdpMid}",
    // "sdpMLineIndex": e.sdpMlineIndex.toString()
    // }
    // };
    // _socket.send(icCandidate);
    // print("these are on new participants icecandidates 1 $icCandidate");
    // } else {
    // print("in ice candidate else");
    // }
    // };
    //print("get local description ${getLocalDescription()}");
    Map<String, dynamic> offerJson = {
      "type": "request",
      "requestType": "re_invite",
      "session_type": startCallObject["sessionType"],
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "referenceID": ref_id,
      "sessionUUID": sessionUUID,
      "mcToken": mcToken,
      "sdpOffer": description.sdp.toString(),
    };
    print("this is mcToken in registerrrrrrrpop ${offerJson}");
    // print("this is json on create offermxnvnsjfnsjfnd $offerJson");
    sessionUUID = offerJson["sessionUUID"];
    // channel.sink.add(offerJson);
    _socket.send(offerJson);
    reConnectCall = 1;
    // print("IN RECOOOONNECTTTTT ${startCallObject["from"]}..${startCallObject["to"]}..$mcTokenCurrent..${ startCallObject["mediaType"]}..${startCallObject["callType"]}..${startCallObject["sessionType"]}");
  }

  // reConnect() async {
  //   //_closeSessionLeftParticipant(ref_id);
  // //  await _createPeerConnection(type: startCallObject["mediaType"]);
  //   // _createOffer(
  //   //     from: startCallObject["from"],
  //   //     to: startCallObject["to"],
  //   //     mcToken: mcTokenCurrent,
  //   //     mediaType: startCallObject["mediaType"],
  //   //     callType: startCallObject["callType"],
  //   //     sessionType: startCallObject["sessionType"]);

  //   RTCSessionDescription description =
  //       await rtcPeerConnectionList[ref_id].createOffer({
  //     "OfferToReceiveAudio": 1,
  //     "OfferToReceiveVideo": 1,
  //   });
  //   await rtcPeerConnectionList[ref_id].setLocalDescription(description);
  //   Map<String, dynamic> offerJson = {
  //     "type": "request",
  //     "requestType": "re_invite",
  //     "session_type": startCallObject["sessionType"],
  //     "requestID": generateMd5(
  //         DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
  //     "referenceID": ref_id,
  //     "sessionUUID": sessionUUID,
  //     "mcToken": mcToken,
  //     "sdpOffer": description.sdp.toString()
  //   };
  //   print("this is mcToken in registerrrrrrrpop   ${offerJson}");
  //   // print("this is json on create offermxnvnsjfnsjfnd $offerJson");
  //   sessionUUID = offerJson["sessionUUID"];
  //   // channel.sink.add(offerJson);
  //   _socket.send(offerJson);
  //   reConnectCall = 1;
  //   //   print("IN RECOOOONNECTTTTT ${startCallObject["from"]}..${startCallObject["to"]}..$mcTokenCurrent..${ startCallObject["mediaType"]}..${startCallObject["callType"]}..${startCallObject["sessionType"]}");
  // }

  register(dynamic user, project_id) {
    print("i am in sdk register");
    // if (isCallStart == 1) {
    //   print("here in re connect");

    //   _closeSessionLeftParticipant(ref_id);
    // }
    ref_id = user["ref_id"];
    Map<String, dynamic> registerjson = {
      "type": "request",
      "requestType": "register",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "projectID": project_id,
      "referenceID": user["ref_id"],
      "authorizationToken": user["authorization_token"],
      "socketType": 0,
      "reConnect": isCallStart
    };

    print("this is json $registerjson   $requestIDType");
    _socket.send(registerjson);
    isCallStart = 1;
  }

  unRegister(String mc_token) {
    Map<String, dynamic> registerjson = {
      "type": "request",
      "requestType": "un_register",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "mcToken": mc_token
    };

    print("this is json $registerjson   $requestIDType");
    _socket.send(registerjson);
  }

  audioVideoState({int audioFlag, int videoFlag, String mcToken}) {
    print("this is statesssssss $audioFlag    $videoFlag");
    Map<String, dynamic> audioVideoStatejson = {
      "type": "request",
      "requestType": "state_information",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "referenceID": ref_id,
      "mcToken": mcToken,
      "sessionUUID": sessionUUID,
      "audioInformation": audioFlag,
      "videoInformation": videoFlag
    };
    print("this is state of audio and video json $audioFlag");

    _socket.send(audioVideoStatejson);
  }

  String generateMd5(String input) {
    return md5.convert(utf8.encode(input)).toString();
  }

  startCallonetoone(
      {String from,
      List<String> to,
      String meidaType,
      String callType,
      String sessionType}) async {
    screenShareflag = false;
    try {
      startCallObject = {"mediaType": meidaType, "sessionType": sessionType};
      callend = false;
      userType = "caller";
      starttime = DateTime.now();
      iscallonetoone = true;
      onetooneparticipantrefid = to[0].toString();
      print("this is one to one participanr ref id $onetooneparticipantrefid ");
      print(
          "this is from one to one session $from, $to, $mcTokenCurrent, $meidaType, $callType, $sessionType");
      _peerConnection = await _createPeerConnectiononetoone(type: meidaType);
      _createOfferonetoone(
          from: from,
          to: to,
          mcToken: mcTokenCurrent,
          mediaType: meidaType,
          callType: callType,
          sessionType: sessionType);
    } catch (e) {
      print("this is error in start call $e");
    }
  }

  _createPeerConnectiononetoone({String type}) async {
    try {
      Map<String, dynamic> configuration = {
        "iceServers": [
          {"url": "stun:stun.l.google.com:19302"},
        ]
      };

      final Map<String, dynamic> offerSdpConstraints = {
        "mandatory": {
          "OfferToReceiveAudio": true,
          "OfferToReceiveVideo": true,
        },
        "optional": [],
      };

      _localStream = await _getUserMedia(type: type);
      // _localStream?.getVideoTracks()[0].enabled = false;
      print("this is local stream in peer connection one to one$_localStream");

      onLocalStream.call(_localStream);
      print("after local stream");
      RTCPeerConnection pc =
          await createPeerConnection(configuration, offerSdpConstraints);
      // var streams = pc.getLocalStreams();
      // for (var stream in streams) {
      //   _localStream = stream;
      // }
      onLocalStream.call(_localStream);
      pc.addStream(_localStream);
      pc.onIceCandidate = (e) {
        if (e.candidate != null) {
          Map<String, dynamic> icCandidate = {
            "requestType": "onIceCandidate",
            "type": "request",
            "referenceID": ref_id,
            "sessionUUID": sessionUUID,
            "candidate": {
              "candidate": "${e.candidate}",
              "sdpMid": "${e.sdpMid}",
              "sdpMLineIndex": e.sdpMlineIndex.toString()
            }
          };
          _socket.send(icCandidate);
        }
      };

      pc.onIceConnectionState = (e) {};
      // for remote strem

      pc.onAddStream = (stream) {
        print("this is remote stream ${stream.id}");
        onRemoteStream.call(stream, onetooneparticipantrefid);
      };
      for (int i = 0; i < _localStream.getTracks().length; i++) {
        Timer.periodic(Duration(seconds: 2), (Timer t) {
          print("THIS is is timer periodic");
          if (callend == true) {
            print("this iis in call endv");
            t.cancel();
            print("in new participant timer cancleeee");
          }
          _peerConnection
              .getStats(_localStream.getAudioTracks()[i])
              .then((value) => value.forEach((element1) {
                    if (element1.values.containsKey("bytesSent")) {
                      onCallStatsuploads.call(element1.values["bytesSent"]);
                      byteObjectupload = {
                        "totalbytessend": element1.values["bytesSent"],
                      };
                    }
                    if (element1.values.containsKey("bytesReceived")) {
                      onCallstats.call(element1.values["bytesReceived"],
                          element1.values["bytesSent"]);
                      byteObject = {
                        "totalbytereceived": element1.values["bytesReceived"],
                        "sessionUUID": sessionUUID,
                      };
                      incrementvariable = incrementvariable + 2;
                      print(
                          "THIS IS incremenr variable value $incrementvariable...... $bytesInterval");
                      if (incrementvariable % bytesInterval == 0) {
                        print(
                            "FHFHFHFHFHFFHH pppppp${byteObjectupload["totalbytessend"].toString()}");
                        print("I am in byte interval mod");
                        Map<String, dynamic> statsjson = {
                          "mcToken":
                              mcTokenCurrent == "" ? mcToken : mcTokenCurrent,
                          "referenceID": ref_id,
                          "requestID": generateMd5(
                              DateTime.now().millisecondsSinceEpoch.toString() +
                                  tenantID +
                                  ref_id),
                          "sessionUUID": sessionUUID,
                          "stats": {
                            "type": "bytes",
                            "upload_bytes":
                                byteObjectupload["totalbytessend"].toString(),
                            "download_bytes":
                                element1.values["bytesReceived"].toString()
                          },
                          "type": "request",
                          "requestType": "stats_information"
                        };
                        print("THIS IS STATS OBJECT $statsjson");
                        _socket.send(statsjson);
                      }
                      statsss = element1.values["bytesReceived"];
                      print("SSSSSSPSPSPSSPSPSPSPSP $statsss");
                    }
                  }));
        });
      }
      return pc;
    } catch (e) {
      print("this is error in _createPeerConnection$e");
    }
  }

  startCall(
      {String from,
      List<String> to,
      String mcToken,
      String meidaType,
      String callType,
      String sessionType}) async {
    screenShareflag = false;
    mcTokenCurrent = mcToken;
    try {
      print("this is sdk $meidaType");
      mediatype = meidaType;
      startCallObject = {
        "from": from,
        "to": to,
        "mediaType": meidaType,
        "callType": callType,
        "sessionType": sessionType
      };
      //  callParticipants = to[0];
      print("THSI IS STARTCALL OBJECT $startCallObject");
      // RTCPeerConnection temp = await newParticipantsPeerConnection();

      // rtcPeerConnectionList.addAll({
      //   mapData["referenceID"]: {"peerConnection": temp},
      // });
      // _createOfferForNewParticipant(to: mapData["referenceID"].toString());
      // onReceiveCallFromUser.call(mapData["from"], mapData["media_type"]);
// Map<String, String> forSessionInvite = {
//   "requestType":"session_invite",
//   "media_type":meidaType,
//   "referenceID":from
// };

// RTCPeerConnection temp = await newParticipantsPeerConnection(forSessionInvite);

      await _createPeerConnection(type: meidaType);
      // rtcPeerConnectionList.addAll({
      //   ref_id: temp,
      // });
      _createOffer(
          from: from,
          to: to,
          mcToken: mcToken,
          mediaType: meidaType,
          callType: callType,
          sessionType: sessionType);
    } catch (e) {
      print("this is error $e");
    }
  }

  incomingCallonetoone(mapData) async {
    startCallObject = {
      "mediaType": mapData["media_type"],
      "sessionType": mapData["session_type"]
    };
    _peerConnection =
        await _createPeerConnectiononetoone(type: mapData["media_type"]);
    // onReceiveCallFromUser.call(name, type);
    print("this is pee coneection in incoming one to one $_peerConnection");
    onReceiveCallFromUser.call(mapData["from"], mapData["media_type"], true);
  }

  incomingCall(mapData) async {
    // RTCPeerConnection temp =
    print("THIS ISIDIDIDIDIDDIDIDIDI $mapData");
    startCallObject = {
      "from": mapData["from"],
      "to": mapData["participants"],
      "mediaType": mapData["media_type"],
      "callType": mapData["call_type"],
      "sessionType": mapData["session_type"]
    };
    // callParticipants = mapData["from"];
    // print("this is call participants list ${callParticipants}");
    await _createPeerConnection(type: mapData["media_type"]);
    // rtcPeerConnectionList.addAll({
    //   ref_id: temp,
    // });

    // RTCPeerConnection temp = await newParticipantsPeerConnection(mapData);

    // rtcPeerConnectionList.addAll({
    //   mapData["from"]: {"peerConnection": temp},
    // });
    // _createOfferForNewParticipant(to: mapData["from"].toString());
    onReceiveCallFromUser.call(mapData["from"], mapData["media_type"], false);
  }

  handleExistingParticipant(mapData) async {
    // if (reConnectCall == 1) {
    //   //_closeSession();
    //   _closeSessionLeftParticipant(mapData["referenceID"]);
    // }
    print("This is peer connection list in existing ${mapData}");
    for (var i = 0; i < mapData["referenceIDs"].length; i++) {
      print("call before $callParticipants");
      callParticipants.add(mapData["referenceIDs"][i]);
      // callParticipants[i] = mapData["referenceIDs"][i].toString();
      print("call after $callParticipants");
    }
    print(
        "This is peer connection list in existingafterrrrrrrr $callParticipants");
    // callParticipants.add(mapData["referenceIDs"]);
    // print("this is call participants in exisiting $callParticipants");
    print("existing participant handle");
    incrementvariable = 0;
    userType = "callee";
    starttime = DateTime.now();
    callend = false;
    print(
        "this is newparticipants dataaaaaaaaaaattttttttttt ${mapData["referenceIDs"].first},  $rtcPeerConnectionList....${mapData["media_type"]}");
    for (var i = 0; i < mapData["referenceIDs"].length; i++) {
      if (rtcPeerConnectionList.containsKey(mapData["referenceIDs"][i])) {
        // _createOfferForNewParticipant(to: mapData["referenceIDs"][i]);
      } else {
        await newParticipantsPeerConnection(
            mapData["referenceIDs"][i], onRemoteStream);
        _createOfferForNewParticipant(to: mapData["referenceIDs"][i]);
      }
    }
    print("THISIS IN AUDIO");

    for (int i = 0; i < _localStream.getTracks().length; i++) {
      rtcPeerConnectionList[mapData["referenceIDs"][i]]
          .getStats(_localStream.getAudioTracks()[i])
          .then((value) => value.forEach((element) {
                print(
                    "this is value before ice candidate ${element.timestamp}");
              }));
      Timer.periodic(Duration(seconds: 2), (Timer t) {
        if (callend == true) {
          t.cancel();
          print("in new participant timer cancleeee");
        }
        rtcPeerConnectionList[mapData["referenceIDs"][i]]
            .getStats(_localStream.getAudioTracks()[i])
            .then((value) => value.forEach((element1) {
                  if (element1.values.containsKey("bytesSent")) {
                    onCallStatsuploads.call(element1.values["bytesSent"]);
                    byteObjectupload = {
                      "totalbytessend": element1.values["bytesSent"],
                    };
                    print(
                        "FHFHFHFHFHFFHH pppppp${byteObjectupload["totalbytessend"].toString()}");
                  }
                  if (element1.values.containsKey("bytesReceived")) {
                    onCallstats.call(element1.values["bytesReceived"],
                        element1.values["bytesSent"]);
                    byteObject = {
                      "totalbytereceived": element1.values["bytesReceived"],
                      "sessionUUID": sessionUUID,
                    };
                    incrementvariable = incrementvariable + 2;
                    print(
                        "THIS IS incremenr variable value $incrementvariable...... $bytesInterval");
                    if (incrementvariable % bytesInterval == 0) {
                      print("I am in byte interval mod");
                      Map<String, dynamic> statsjson = {
                        "mcToken":
                            mcTokenCurrent == "" ? mcToken : mcTokenCurrent,
                        "referenceID": ref_id,
                        "requestID": generateMd5(
                            DateTime.now().millisecondsSinceEpoch.toString() +
                                tenantID +
                                ref_id),
                        "sessionUUID": sessionUUID,
                        "stats": {
                          "type": "bytes",
                          "upload_bytes":
                              byteObjectupload["totalbytessend"].toString(),
                          "download_bytes":
                              element1.values["bytesReceived"].toString()
                        },
                        "type": "request",
                        "requestType": "stats_information"
                      };
                      print("THIS IS STATS OBJECT $statsjson");
                      _socket.send(statsjson);
                    }
                    statsss = element1.values["bytesReceived"];
                    print("SSSSSSPSPSPSSPSPSPSPSP $statsss");
                  }
                }));
      });
    }
  }

  handleNewParticipant(mapData) async {
    // if (iscallreconnected == true) {
    //   for (int i = 0; i < callParticipants.length; i++) {
    //     rtcPeerConnectionList.forEach((key, value) {
    //       if (key == participntleftreferenceid) {
    //         print("here in iscallstart1");
    //         rtcPeerConnectionList[key]?.close();
    //       }
    //       // rtcPeerConnectionList[key]?.close();
    //     });
    //     onParticipantsLeft.call(participntleftreferenceid);
    //     rtcPeerConnectionList.remove(participntleftreferenceid);
    //   }

    //   //          await _createPeerConnection(type: "video");
    //   // RTCSessionDescription description =
    //   //     await rtcPeerConnectionList[ref_id].createOffer({
    //   //   "OfferToReceiveAudio": 1,
    //   //   "OfferToReceiveVideo": 1,
    //   // });
    //   // await rtcPeerConnectionList[ref_id].setLocalDescription(description);
    //   //   // rtcPeerConnectionList.forEach((key, value) {
    //   //   if (key == callParticipants) {
    //   //     print("here in iscallstart1");
    //   //     rtcPeerConnectionList[key]?.close();
    //   //     onParticipantsLeft.call(callParticipants);
    //   //   }
    //   //   // rtcPeerConnectionList[key]?.close();
    //   // });
    //   // rtcPeerConnectionList.remove(callParticipants);
    // }
    //   print("EGJHSJGHJGBJGBGBVJXBVJSNBFHJ");
    //   _closeSessionLeftParticipant(participntleftreferenceid);
    print(
        "this is reference id in handle new participant ${mapData["referenceID"]}");
    callParticipants.add(mapData["referenceID"]);
    // print("This is call participants in handle new $callParticipants");
    print("new participant handle");
    userType = "caller";
    starttime = DateTime.now();
    callend = false;
    await newParticipantsPeerConnection(mapData["referenceID"], onRemoteStream);

    _createOfferForNewParticipant(to: mapData["referenceID"]);
    //if(mediatype=="audio"){
    for (int i = 0; i < _localStream.getTracks().length; i++) {
      // print("this is onn forfffffff ${rtcPeerConnectionList[mapData["referenceID"]].getStats(_localStream.getAudioTracks()[0])}");

      rtcPeerConnectionList[mapData["referenceID"]]
          .getStats(_localStream.getAudioTracks()[i])
          .then((value) => value.forEach((element) {
                print(
                    "this is value before ice candidateeeeeeeeeee ${element.timestamp}");
              }));

      Timer.periodic(Duration(seconds: 2), (Timer t) {
        if (callend == true) {
          t.cancel();
          print("in new participant timer cancle");
        }
        rtcPeerConnectionList[mapData["referenceID"]]
            .getStats(_localStream.getAudioTracks()[i])
            .then((value) => value.forEach((element1) {
                  print("this is value in ice candidate ${element1.values}");
                  print(
                      "@@@#@#@#@#@#@#@@##@#@#@#@+++++++${element1.values["bytesSent"]}");
                  if (element1.values.containsKey("bytesSent")) {
                    print(
                        "this is newparticipants dataaaaaaaaaaattttttttttt ${element1.values["bytesSent"]}....${element1.values["bytesReceived"]}");
                    onCallStatsuploads.call(element1.values["bytesSent"]);
                    byteObjectupload = {
                      "totalbytessend": element1.values["bytesSent"],
                    };
                    print(
                        "FHFHFHFHFHFFHH ${byteObjectupload["totalbytessend"].toString()}");
                  }
                  if (element1.values.containsKey("bytesReceived")) {
                    onCallstats.call(element1.values["bytesReceived"],
                        element1.values["bytesSent"]);
                    byteObject = {
                      "totalbytereceived": element1.values["bytesReceived"],
                      "sessionUUID": sessionUUID,
                    };
                    incrementvariable = incrementvariable + 2;
                    print(
                        "THIS IS incremenr variable value $incrementvariable...... $bytesInterval");
                    if (incrementvariable % bytesInterval == 0) {
                      print("I am in byte interval mod");
                      Map<String, dynamic> statsjson = {
                        "mcToken":
                            mcTokenCurrent == "" ? mcToken : mcTokenCurrent,
                        "referenceID": ref_id,
                        "requestID": generateMd5(
                            DateTime.now().millisecondsSinceEpoch.toString() +
                                tenantID +
                                ref_id),
                        "sessionUUID": sessionUUID,
                        "stats": {
                          "type": "bytes",
                          "upload_bytes":
                              byteObjectupload["totalbytessend"].toString(),
                          "download_bytes":
                              element1.values["bytesReceived"].toString()
                        },
                        "type": "request",
                        "requestType": "stats_information"
                      };
                      print("THIS IS STATS OBJECT $statsjson");
                      _socket.send(statsjson);
                    }
                    statsss = element1.values["bytesReceived"];
                    print("SSSSSSPSPSPSSPSPSPSPSP $statsss");
                  }
                }));
      });
    }
  }

  newParticipantsPeerConnection(
      refID, OnRemoteStreamCallback remoteCallBack) async {
    try {
      Map<String, dynamic> configuration = {
        "iceServers": [
          {"url": "stun:stun.l.google.com:19302"},
        ]
      };

      final Map<String, dynamic> offerSdpConstraints = {
        "mandatory": {
          "OfferToReceiveAudio": true,
          "OfferToReceiveVideo": true,
        },
        "optional": [],
      };
      print("this is local stream $offerSdpConstraints");
      rtcPeerConnectionList[refID] =
          await createPeerConnection(configuration, offerSdpConstraints);

      print(
          "this is create of second peer connection  $rtcPeerConnectionList ${rtcPeerConnectionList[refID]}");
      rtcPeerConnectionList[refID].addStream(_localStream);
      rtcPeerConnectionList[refID].onIceCandidate = (e) {
        if (e.candidate != null) {
          Map<String, dynamic> icCandidate = {
            "requestType": "onIceCandidate",
            "type": "request",
            "referenceID": refID,
            "sessionUUID": sessionUUID,
            "candidate": {
              "candidate": "${e.candidate}",
              "sdpMid": "${e.sdpMid}",
              "sdpMLineIndex": e.sdpMlineIndex.toString()
            }
          };

          print("these are on new participants icecandidates $icCandidate");
          _socket.send(icCandidate);
        }
      };

      rtcPeerConnectionList[refID].onIceConnectionState = (e) {};
      // for remote strem

      rtcPeerConnectionList[refID].onAddStream = (stream) {
        print(
            "this is remote stream ${stream.id}  ${rtcPeerConnectionList.length}");
        var time;
        var diff;
        remoteCallBack.call(stream, refID);
      };
    } catch (e) {
      print("this is error $e");
    }
  }

  statsEndCall() async {
    if (Device.get().isTablet) {
      deviceCategory = "tablet";
      print("this is device category $deviceCategory");
    } else if (Device.get().isPhone) {
      deviceCategory = "mobile";
      print("this is device category $deviceCategory");
    } else {}
    if (Device.get().isAndroid) {
      deviceType = "android";
      DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
      AndroidDeviceInfo androidInfo = await deviceInfo.androidInfo;
      deviceModel = androidInfo.model.toString();
      print("this is android info $deviceModel");
    } else {
      deviceType = "ios";
      DeviceInfoPlugin deviceInfo = DeviceInfoPlugin();
      IosDeviceInfo iosInfo = await deviceInfo.iosInfo;
      deviceModel = iosInfo.model.toString();
    }
    final ipv4 = await Ipify.ipv4();
    // var wifiIP = await WifiInfo().getWifiIP();
    print(
        "THIS IS start TYPEEEEEEEE ${byteObject["totalbytereceived"].toString()}");

    Map<String, dynamic> callEndStatsjsonData = {
      "mcToken": mcTokenCurrent == "" ? mcToken : mcTokenCurrent,
      "referenceID": ref_id,
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "sessionUUID": byteObject["sessionUUID"],
      "stats": {
        "type": "data",
        "user_type": userType,
        "join_time": starttime.millisecondsSinceEpoch.toString(),
        "left_time": DateTime.now().millisecondsSinceEpoch.toString(),
        "device_category": deviceCategory,
        "device_type": deviceType,
        "device_model": deviceModel,
        "device_os": Platform.operatingSystemVersion.toString(),
        "local_ip": "192.168.0.1",
        "public_ip": ipv4,
        "battery_usage": "0",
        "total_uploaded_bytes": byteObjectupload["totalbytessend"].toString(),
        "total_downloaded_bytes": byteObject["totalbytereceived"].toString()
      },
      "type": "request",
      "requestType": "stats_information"
    };
    print("THIIS IS CALL END STATSSSSSSS $callEndStatsjsonData");
    _socket.send(callEndStatsjsonData);
  }

  stopCall(mcToken) {
    print("this is stop call in sdk $mcToken");

    Map<String, dynamic> jsonData = {
      "type": "request",
      "requestType": "session_cancel",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "sessionUUID": sessionUUID,
      "mcToken": mcToken
    };
    _socket.send(jsonData);
    // _peerConnection.close();
    _closeSession();
    callend = true;
    callversions = 0;
    iscallonetoone = false;
    statsEndCall();
  }

  _createOfferForNewParticipant({String to}) async {
    print("this is to $to  ${rtcPeerConnectionList[to]}");
    // print(
    //     "this is create offern lsdjflsjlfjsd ${rtcPeerConnectionList["${to.toString()}"]}");

    // RTCPeerConnection _temp = rtcPeerConnectionList["${to.toString()}"];
    try {
      RTCSessionDescription description =
          await rtcPeerConnectionList[to].createOffer({
        "OfferToReceiveAudio": 1,
        "OfferToReceiveVideo": 1,
      });
      print("this is in create");
      await rtcPeerConnectionList[to].setLocalDescription(description);
      print("this is after description");
      if (reConnectCall == 0) {
        print("This is in if createoffer mctoken $mcTokenCurrent $mcToken");
        Map<String, dynamic> offerJson = {
          "from": ref_id,
          "to": to,
          "type": "request",
          "requestType": "to_receive_stream",
          "requestID": generateMd5(
              DateTime.now().millisecondsSinceEpoch.toString() +
                  tenantID +
                  ref_id),
          "sessionUUID": sessionUUID,
          "mcToken": mcTokenCurrent,
          "sdpOffer": description.sdp.toString()
        };
        print("this is json on create offer $offerJson");
        // sessionUUID = offerJson["sessionUUID"];
        // channel.sink.add(offerJson);
        _socket.send(offerJson);
      } else {
        print("This is in else createoffer mctoken $mcTokenCurrent $mcToken");
        Map<String, dynamic> offerJson = {
          "from": ref_id,
          "to": to,
          "type": "request",
          "requestType": "to_receive_stream",
          "requestID": generateMd5(
              DateTime.now().millisecondsSinceEpoch.toString() +
                  tenantID +
                  ref_id),
          "sessionUUID": sessionUUID,
          "mcToken": mcToken,
          "sdpOffer": description.sdp.toString()
        };
        print("this is json on create offer $offerJson");
        // sessionUUID = offerJson["sessionUUID"];
        // channel.sink.add(offerJson);
        _socket.send(offerJson);
      }

      // requestIDType[offerJson["requestID"]] = "call";

    } catch (e) {
      print("this is error in createoffernew $e");
    }
  }

  _createOfferonetoone(
      {String from,
      List<String> to,
      String mcToken,
      String mediaType,
      String callType,
      String sessionType}) async {
    print(
        "this is create offer $from , $to, $mcToken, $mediaType, $callType, $sessionType");
    try {
      RTCSessionDescription description = await _peerConnection.createOffer({
        "OfferToReceiveAudio": 1,
        "OfferToReceiveVideo": 1,
      });
      await _peerConnection.setLocalDescription(description);
      Map<String, dynamic> offerJson = {
        "from": from,
        "to": to,
        "type": "request",
        "requestType": "session_invite",
        "session_type": sessionType,
        "call_type": callType,
        "media_type": mediaType,
        "requestID": generateMd5(
            DateTime.now().millisecondsSinceEpoch.toString() +
                tenantID +
                ref_id),
        "sessionUUID": generateMd5(
            DateTime.now().millisecondsSinceEpoch.toString() +
                tenantID +
                ref_id),
        "mcToken": mcToken,
        "sdpOffer": description.sdp.toString()
      };
      // requestIDType[offerJson["requestID"]] = "call";
      print("this is json on create offer $offerJson");
      sessionUUID = offerJson["sessionUUID"];
      // channel.sink.add(offerJson);
      _socket.send(offerJson);
    } catch (e) {
      print("this is error in peer connection $e");
    }
  }

  _createOffer(
      {String from,
      List<String> to,
      String mcToken,
      String mediaType,
      String callType,
      String sessionType}) async {
    print("this is create offer $ref_id");
    try {
      RTCSessionDescription description =
          await rtcPeerConnectionList[ref_id].createOffer({
        "OfferToReceiveAudio": 1,
        "OfferToReceiveVideo": 1,
      });
      await rtcPeerConnectionList[ref_id].setLocalDescription(description);
      Map<String, dynamic> offerJson = {
        "from": from,
        "to": to,
        "type": "request",
        "requestType": "session_invite",
        "session_type": sessionType,
        "call_type": callType,
        "media_type": mediaType,
        "requestID": generateMd5(
            DateTime.now().millisecondsSinceEpoch.toString() +
                tenantID +
                ref_id),
        "sessionUUID": generateMd5(
            DateTime.now().millisecondsSinceEpoch.toString() +
                tenantID +
                ref_id),
        "mcToken": mcTokenCurrent,
        "sdpOffer": description.sdp.toString()
      };
      // requestIDType[offerJson["requestID"]] = "call";
      print("this is json on create offer $offerJson");
      sessionUUID = offerJson["sessionUUID"];
      // channel.sink.add(offerJson);
      _socket.send(offerJson);
    } catch (e) {
      print("this is error $e");
    }
  }

  createAnswer(refID) async {
    if (iscallonetoone == true) {
      callend = false;
      incrementvariable = 0;
      userType = "callee";
      starttime = DateTime.now();
      print("this is in one to one create answer $refID");
      try {
        print("this is peerConnection $_peerConnection");
        RTCSessionDescription description = await _peerConnection.createOffer({
          "OfferToReceiveAudio": 1,
          "OfferToReceiveVideo": 1,
        });
        // RTCSessionDescription description =
        //     await _peerConnection.createAnswer({'offerToReceiveVideo': 1});

        // var session = parse(description.sdp);
        // print(json.encode(session));
        // print(json.encode({
        //       'sdp': description.sdp.toString(),
        //       'type': description.type.toString(),
        //     }));

        _peerConnection.setLocalDescription(description);
        final Map<String, dynamic> _offerJson = {
          "type": "request",
          "requestID": generateMd5(
              DateTime.now().millisecondsSinceEpoch.toString() +
                  tenantID +
                  ref_id),
          "sessionUUID": sessionUUID,
          "requestType": "session_invite",
          "responseCode": 200,
          "responseMessage": "accepted",
          "sdpOffer": description.sdp.toString()
        };
        print("this is offer json in one to one  $_offerJson");
        _socket.send(_offerJson);
        // channel.sink.add(_offerJson);
      } catch (e) {
        print("this is error in create answer$e");
      }
    } else {
      print("this is name $refID  ${rtcPeerConnectionList[ref_id]}");

      try {
        print(
            "this is peer connection in create answer ${rtcPeerConnectionList[ref_id]}");
        RTCSessionDescription description =
            await rtcPeerConnectionList[ref_id].createOffer({
          "OfferToReceiveAudio": 1,
          "OfferToReceiveVideo": 1,
        });
        // RTCSessionDescription description =
        //     await _peerConnection.createAnswer({'offerToReceiveVideo': 1});

        // var session = parse(description.sdp);
        // print(json.encode(session));
        // print(json.encode({
        //       'sdp': description.sdp.toString(),
        //       'type': description.type.toString(),
        //     }));

        rtcPeerConnectionList[ref_id].setLocalDescription(description);
        final Map<String, dynamic> _offerJson = {
          "type": "request",
          "requestID": generateMd5(
              DateTime.now().millisecondsSinceEpoch.toString() +
                  tenantID +
                  ref_id),
          "sessionUUID": sessionUUID,
          "requestType": "session_invite",
          "responseCode": 200,
          "responseMessage": "accepted",
          "sdpOffer": description.sdp.toString()
        };
        print("this is offer json in many to many $_offerJson");
        _socket.send(_offerJson);
        // channel.sink.add(_offerJson);
      } catch (e) {
        print("this is error $e");
      }
    }
  }

  onSessionTimeOut(mcToken) {
    print("i am in session timeout");
    Map<String, dynamic> newJsonData = {
      "requestType": "session_timeout",
      "mcToken": mcToken,
      "sessionUUID": sessionUUID,
      "referenceID": ref_id,
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id)
    };
    print("This is session timeout json rpc ${newJsonData}");
    _socket.send(newJsonData);
  }

  onDeclineCall(from, mcToken) {
    Map<String, dynamic> jsonData = {
      "type": "response",
      "from": from,
      "requestType": "session_cancel",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "sessionUUID": sessionUUID,
      "mcToken": mcToken
      // "responseCode": 487,
      // "responseMessage": "rejected"
    };

    print("this is json data $jsonData");
    _socket.send(jsonData);

    _closeSession();
  }

  onCancelbytheCaller(mcToken) {
    Map<String, dynamic> jsonData = {
      "type": "request",
      "requestType": "session_cancel",
      "requestID": generateMd5(
          DateTime.now().millisecondsSinceEpoch.toString() + tenantID + ref_id),
      "sessionUUID": sessionUUID,
      "mcToken": mcToken
    };
    _socket.send(jsonData);

    _closeSession();
    print("THIS IS CALL CANCEL BY OTHER CALLER");
  }

  _createPeerConnection({String type}) async {
    try {
      Map<String, dynamic> configuration = {
        "iceServers": [
          {"url": "stun:stun.l.google.com:19302"},
        ]
      };

      final Map<String, dynamic> offerSdpConstraints = {
        "mandatory": {
          "OfferToReceiveAudio": true,
          "OfferToReceiveVideo": true,
        },
        "optional": [],
      };

      _localStream = await _getUserMedia(type: type);
      // _localStream?.getVideoTracks()[0].enabled = false;
      print("this is local stream peer connectuo many to manyh $_localStream");

      rtcPeerConnectionList[ref_id] =
          await createPeerConnection(configuration, offerSdpConstraints);

      print(
          "in create peer connection $rtcPeerConnectionList  ${rtcPeerConnectionList[ref_id]}");
      // var streams = pc.getLocalStreams();
      // for (var stream in streams) {
      //   _localStream = stream;
      // }
      onLocalStream.call(_localStream);
      rtcPeerConnectionList[ref_id].addStream(_localStream);
      print("THis is peerCOnnection List");
      //  print("this is start --${rtcPeerConnectionList["referenceID"].getStats(_localStream.getAudioTracks()[0])}");
      rtcPeerConnectionList[ref_id].onIceCandidate = (e) {
        if (e.candidate != null) {
          Map<String, dynamic> icCandidate = {
            "requestType": "onIceCandidate",
            "type": "request",
            "referenceID": ref_id,
            "sessionUUID": sessionUUID,
            "candidate": {
              "candidate": "${e.candidate}",
              "sdpMid": "${e.sdpMid}",
              "sdpMLineIndex": e.sdpMlineIndex.toString()
            }
          };
          _socket.send(icCandidate);
          print(
              "these are on new participants icecandidates #!!!!!!!!!!!! $icCandidate");
        }
      };

      rtcPeerConnectionList[ref_id].onIceConnectionState = (e) {};

      // for remote strem

      // pc.onAddStream = (stream) {
      //   print("this is remote stream for first ${stream.id}");
      //   onRemoteStream.call(stream);
      // };

      // return _peerConnection;
    } catch (e) {
      print("this is error $e");
    }
  }

  void switchCamera() {
    if (_localStream != null) {
      _localStream.getVideoTracks()[0].switchCamera();
    }
  }

  void enableCamera(enabled) {
    print("this is bool $enabled");
    if (_localStream != null) {
      // _localStream.getVideoTracks()[0].switchCamera();
      _localStream?.getVideoTracks()[0].enabled = enabled;
    }
  }

  muteMic() {
    if (_localStream != null) {
      bool enabled = _localStream.getAudioTracks()[0].enabled;
      _localStream.getAudioTracks()[0].enabled = !enabled;
      print("this is local ${_localStream.getAudioTracks()[0].enabled}");
      return !enabled;
    }
  }

  switchSpeaker(flag) {
    if (_localStream != null) {
      _localStream?.getAudioTracks()[0].enableSpeakerphone(flag);
    }
  }

  _getUserMedia({String type}) async {
    try {
      Map<String, dynamic> mediaConstraints = {
        'audio': false,
        'video': {
          // "height": {"min": "812", "ideal": "1920"},
          'mandatory': {
            //  'minWidth': '640',
            //   "maxWidth": '640',
            //   'minHeight': '1319',
            //   "maxHeight": '640',

            //   "minWidth":'640', // Provide your own width, height and frame rate here
            // "minHeight": '480',
            // "minFrameRate": '30',
          },
          'facingMode': 'user',
          // 'optional': [],
        }
      };
      Map<String, dynamic> onlyAudio = {'audio': true};

      _audioStream =
          await navigator.mediaDevices.getUserMedia(onlyAudio).catchError((e) {
        print("this is error audio  $e");
      });
      if (type == "video") {
        return await
            // navigator.getDisplayMedia(mediaConstraints)
            navigator.mediaDevices.getUserMedia(mediaConstraints).then((value) {
          print("this is stream ${value}");
          _audioStream.getAudioTracks().forEach((element) {
            value.addTrack(element);
          });
          if (!kIsWeb) value?.getAudioTracks()[0].enableSpeakerphone(true);
          return value;
        }).catchError((onError) {
          print("this is error $onError");
        });
      } else {
        if (!kIsWeb)
          _audioStream?.getAudioTracks()[0].enableSpeakerphone(false);
        return _audioStream;
      }

      if (screenShareflag) {
        // return await navigator.getDisplayMedia(mediaConstraints)
        //     // navigator.mediaDevices.getUserMedia(mediaConstraints)
        //     .then((value) {
        //   print("this is stream ${value}");
        //   // _audioStream.getAudioTracks().forEach((element) {
        //   //   value.addTrack(element);
        //   // });
        //   return value;
        // }).catchError((onError) {
        //   print("this is error $onError");
        // });
      } else {
        // return await
        //     // navigator.getDisplayMedia(mediaConstraints)
        //     navigator.mediaDevices.getUserMedia(mediaConstraints).then((value) {
        //   print("this is stream ${value}");
        //   _audioStream.getAudioTracks().forEach((element) {
        //     value.addTrack(element);
        //   });
        //   return value;
        // }).catchError((onError) {
        //   print("this is error $onError");
        // });
        // if (Platform.isAndroid) {
        //   if (_localStream == null) {
        //     // define initial variable here for ability to call stop() on each track

        //     return await navigator.mediaDevices
        //         .getDisplayMedia(mediaConstraints)
        //         .then((displayStream) async {
        //       audioStream.getAudioTracks().forEach((element) {
        //         displayStream.addTrack(element);
        //       });
        //       return displayStream;
        //       // return await displayStream
        //       //     .addTrack(audioStream.getTracks()[0]); // do stuff
        //       // or
        //       // do stuff
        //     }).catchError((e) {
        //       print("this is error over all $e");
        //     });

        //     // return await navigator.mediaDevices
        //     //     .getUserMedia(mediaConstraints)
        //     //     .then((value) {
        //     //   print("this is stream ${value.id}");
        //     //   audioStream.getAudioTracks().forEach((element) {
        //     //     value.addTrack(element);
        //     //   });
        //     //   return value;
        //     // }).catchError((onError) {
        //     //   print("this is error $onError");
        //     // });
        //   } else {
        //     return _localStream;
        //   }
        // } else {
        //   print("teseting ");
        //   // ReplayKitLauncher.launchReplayKitBroadcast('sharescreen');
        //   return await
        //       // navigator.mediaDevices.getDisplayMedia(mediaConstraints);
        //       navigator.mediaDevices
        //           .getUserMedia(mediaConstraints)
        //           .then((value) {
        //     audioStream.getAudioTracks().forEach((element) {
        //       value.addTrack(element);
        //     });
        //     print("this is stream ${value.id}");
        //     return value;
        //   }).catchError((onError) {
        //     print("this is error $onError");
        //   });
        // }
      }

      // }
      // } else {
      //   stream = await navigator.mediaDevices
      //       .getUserMedia(mediaConstraints)
      //       .then((value) => value)
      //       .catchError((onError) {
      //     print("this is error $onError");
      //   });
      // }

      // _localStream = stream;
      // _localRenderer.srcObject = stream;
      // _localRenderer.mirror = true;

      // _peerConnection.addStream(stream);

      // return stream;
    } catch (e) {
      print("this is error $e");
    }
  }

  Future<void> _closeSession() async {
    print("this is close session");
    _localStream?.getTracks()?.forEach((element) async {
      await element.stop();
    });
    await _localStream?.dispose();
    _localStream = null;

    await _peerConnection?.close();
    await _peerConnection2?.close();

    rtcPeerConnectionList.forEach((key, value) {
      rtcPeerConnectionList[key]?.close();
    });
    rtcPeerConnectionList.clear();

    _audioStream?.getTracks()?.forEach((element) async {
      await element.stop();
    });
    await _audioStream?.dispose();
    _audioStream = null;

    screenShareflag = false;
    sessionUUID = null;
    requestIDType.clear();
  }

  Future<void> _closeSessionLeftParticipant(refID) async {
    print("this is close session");

    await rtcPeerConnectionList[refID]?.close();
    rtcPeerConnectionList.remove(refID);
  }
}
